searchData={"items":[{"type":"module","title":"FilterEx.ExpAverage","doc":"","ref":"FilterEx.ExpAverage.html"},{"type":"function","title":"FilterEx.ExpAverage.update/2","doc":"","ref":"FilterEx.ExpAverage.html#update/2"},{"type":"module","title":"FilterEx.Kalman","doc":"","ref":"FilterEx.Kalman.html"},{"type":"function","title":"FilterEx.Kalman.adaptive_eps/2","doc":"","ref":"FilterEx.Kalman.html#adaptive_eps/2"},{"type":"function","title":"FilterEx.Kalman.adaptive_stddev/2","doc":"","ref":"FilterEx.Kalman.html#adaptive_stddev/2"},{"type":"function","title":"FilterEx.Kalman.estimate/1","doc":"","ref":"FilterEx.Kalman.html#estimate/1"},{"type":"function","title":"FilterEx.Kalman.filter/3","doc":"","ref":"FilterEx.Kalman.html#filter/3"},{"type":"function","title":"FilterEx.Kalman.new/1","doc":"Parameters\n  ----------\n  dim_x : int\n      Number of state variables for the Kalman filter. For example, if\n      you are tracking the position and velocity of an object in two\n      dimensions, dim_x would be 4.\n      This is used to set the default size of P, Q, and u\n\n  dim_z : int\n      Number of of measurement inputs. For example, if the sensor\n      provides you with position in (x,y), dim_z would be 2.\n\n  dim_u : int (optional)\n      size of the control input, if it is being used.\n      Default value of 0 indicates it is not used.","ref":"FilterEx.Kalman.html#new/1"},{"type":"function","title":"FilterEx.Kalman.predict/5","doc":"Predict next state (prior) using the Kalman filter state propagation\nequations.\n\nParameters\n----------\n\nu : np.array, default 0\n    Optional control vector.\n\nB : np.array(dim_x, dim_u), or None\n    Optional control transition matrix; a value of None\n    will cause the filter to use `self.B`.\n\nF : np.array(dim_x, dim_x), or None\n    Optional state transition matrix; a value of None\n    will cause the filter to use `self.F`.\n\nQ : np.array(dim_x, dim_x), scalar, or None\n    Optional process noise matrix; a value of None will cause the\n    filter to use `self.Q`.","ref":"FilterEx.Kalman.html#predict/5"},{"type":"function","title":"FilterEx.Kalman.residual/1","doc":"","ref":"FilterEx.Kalman.html#residual/1"},{"type":"function","title":"FilterEx.Kalman.to_eps_adaptive/2","doc":"","ref":"FilterEx.Kalman.html#to_eps_adaptive/2"},{"type":"function","title":"FilterEx.Kalman.to_stddev_adaptive/2","doc":"","ref":"FilterEx.Kalman.html#to_stddev_adaptive/2"},{"type":"function","title":"FilterEx.Kalman.update/4","doc":"Add a new measurement (z) to the Kalman filter.\n\n  If z is None, nothing is computed. However, x_post and P_post are\n  updated with the prior (x_prior, P_prior), and self.z is set to None.\n\n  Parameters\n  ----------\n  z : (dim_z, 1): array_like\n      measurement for this update. z can be a scalar if dim_z is 1,\n      otherwise it must be convertible to a column vector.\n\n      If you pass in a value of H, z must be a column vector the\n      of the correct size.\n\n  R : np.array, scalar, or None\n      Optionally provide R to override the measurement noise for this\n      one call, otherwise  self.R will be used.\n\n  H : np.array, or None\n      Optionally provide H to override the measurement function for this\n      one call, otherwise self.H will be used.","ref":"FilterEx.Kalman.html#update/4"},{"type":"module","title":"FilterEx.Utils","doc":"","ref":"FilterEx.Utils.html"},{"type":"function","title":"FilterEx.Utils.block_diag/1","doc":"Creates a block diagonal matrix from a list of matrices using Nx.","ref":"FilterEx.Utils.html#block_diag/1"},{"type":"function","title":"Examples - FilterEx.Utils.block_diag/1","doc":"iex> qQ = Nx.tensor([[1, 2], [3, 4]], type: :f32)\n...> matrices = [qQ, qQ, qQ]  # List of matrices to place on the diagonal\n...> FilterEx.Utils.block_diag(matrices)\nNx.tensor([\n  [1.0, 2.0, 0.0, 0.0, 0.0, 0.0],\n  [3.0, 4.0, 0.0, 0.0, 0.0, 0.0],\n  [0.0, 0.0, 1.0, 2.0, 0.0, 0.0],\n  [0.0, 0.0, 3.0, 4.0, 0.0, 0.0],\n  [0.0, 0.0, 0.0, 0.0, 1.0, 2.0],\n  [0.0, 0.0, 0.0, 0.0, 3.0, 4.0]\n], type: :f32)","ref":"FilterEx.Utils.html#block_diag/1-examples"},{"type":"function","title":"FilterEx.Utils.order_by_derivative/3","doc":"Given a matrix Q, ordered assuming state space\n      [x y z x' y' z' x'' y'' z''...]\n\n  return a reordered matrix assuming an ordering of\n     [ x x' x'' y y' y'' z z' y'']\n\n  This works for any covariance matrix or state transition function\n\n  Parameters\n  ----------\n  Q : np.array, square\n      The matrix to reorder\n\n  dim : int >= 1\n\n     number of independent state variables. 3 for x, y, z\n\n  block_size : int >= 0\n      Size of derivatives. Second derivative would be a block size of 3\n      (x, x', x'')","ref":"FilterEx.Utils.html#order_by_derivative/3"},{"type":"function","title":"FilterEx.Utils.q_discrete_white_noise/2","doc":"Returns the Q matrix for the Discrete Constant White Noise\nModel. dim may be either 2, 3, or 4 dt is the time step, and sigma\nis the variance in the noise.\n\nQ is computed as the G * G^T * variance, where G is the process noise per\ntime step. In other words, G = [[.5dt^2][dt]]^T for the constant velocity\nmodel.\n\nParameters\n-----------\n\ndim : int (2, 3, or 4)\n    dimension for Q, where the final dimension is (dim x dim)\n\ndt : float, default=1.0\n    time step in whatever units your filter is using for time. i.e. the\n    amount of time between innovations\n\nvar : float, default=1.0\n    variance in the noise\n\nblock_size : int >= 1\n    If your state variable contains more than one dimension, such as\n    a 3d constant velocity model [x x' y y' z z']^T, then Q must be\n    a block diagonal matrix.\n\norder_by_dim : bool, default=True\n    Defines ordering of variables in the state vector. `True` orders\n    by keeping all derivatives of each dimensions)\n\n    [x x' x'' y y' y'']\n\n    whereas `False` interleaves the dimensions\n\n    [x y z x' y' z' x'' y'' z'']\n\n\nExamples\n--------\niex> # constant velocity model in a 3D world with a 10 Hz update rate\n...> FilterEx.Utils.q_discrete_white_noise(2, dt: 0.1, var: 1.0, block_size: 3)\nNx.tensor([[0.000025, 0.0005  , 0.0      , 0.0      , 0.0      , 0.0      ],\n           [0.0005  , 0.01    , 0.0      , 0.0      , 0.0      , 0.0      ],\n           [0.0      , 0.0      , 0.000025, 0.0005  , 0.0      , 0.0      ],\n           [0.0      , 0.0      , 0.0005  , 0.01    , 0.0      , 0.0      ],\n           [0.0      , 0.0      , 0.0      , 0.0      , 0.000025, 0.0005  ],\n           [0.0      , 0.0      , 0.0      , 0.0      , 0.0005  , 0.01    ]\n], type: :f32)\n\niex> FilterEx.Utils.q_discrete_white_noise(2, dt: 0.1, var: 1.0, block_size: 3, order_by_dim: false)\nNx.tensor([\n    [2.499999936844688e-5, 0.0, 0.0, 5.000000237487257e-4, 0.0, 0.0],\n    [0.0, 2.499999936844688e-5, 0.0, 0.0, 5.000000237487257e-4, 0.0],\n    [0.0, 0.0, 2.499999936844688e-5, 0.0, 0.0, 5.000000237487257e-4],\n    [5.000000237487257e-4, 0.0, 0.0, 0.009999999776482582, 0.0, 0.0],\n    [0.0, 5.000000237487257e-4, 0.0, 0.0, 0.009999999776482582, 0.0],\n    [0.0, 0.0, 5.000000237487257e-4, 0.0, 0.0, 0.009999999776482582]\n], type: :f32)\n\nReferences\n----------\n\nBar-Shalom. \"Estimation with Applications To Tracking and Navigation\".\nJohn Wiley & Sons, 2001. Page 274.","ref":"FilterEx.Utils.html#q_discrete_white_noise/2"},{"type":"function","title":"FilterEx.Utils.ravel/1","doc":"Flattens the input tensor into a 1D tensor using Nx.","ref":"FilterEx.Utils.html#ravel/1"},{"type":"function","title":"Examples - FilterEx.Utils.ravel/1","doc":"iex> Nx.tensor([[1, 2, 3], [4, 5, 6]], type: :f32) |> FilterEx.Utils.ravel()\nNx.tensor([1.0, 2.0, 3.0, 4.0, 5.0, 6.0], type: :f32)","ref":"FilterEx.Utils.html#ravel/1-examples"},{"type":"function","title":"FilterEx.Utils.reshape_z/3","doc":"ensure z is a (dim_z, 1) shaped vector","ref":"FilterEx.Utils.html#reshape_z/3"},{"type":"function","title":"Examples - FilterEx.Utils.reshape_z/3","doc":"iex> FilterEx.Utils.reshape_z(3.0, 1, 1)\n    Nx.tensor([ 3.0 ], names: [:x])\n\n    iex> FilterEx.Utils.reshape_z(3.0, 1, 2)\n    Nx.tensor([[ 3.0 ]], names: [:x, :y])\n\n    iex> FilterEx.Utils.reshape_z([3.0], 1, 1)\n    Nx.tensor([ 3.0 ], names: [:x])\n\n    iex> FilterEx.Utils.reshape_z([3.0], 1, 2)\n    Nx.tensor([[3.0]], names: [:x, :y])\n\n    iex> FilterEx.Utils.reshape_z([3.0,2.0], 2, 1)\n    Nx.tensor([3.0, 2.0], names: [:x])\n\n    iex> FilterEx.Utils.reshape_z([3.0,2.0], 2, 2)\n    Nx.tensor([[3.0], [2.0]], names: [:x, :y])","ref":"FilterEx.Utils.html#reshape_z/3-examples"},{"type":"function","title":"FilterEx.Utils.to_scalar/1","doc":"Get scalar number from a 1, 2, or 3 dimension tensor from zeroth index.","ref":"FilterEx.Utils.html#to_scalar/1"},{"type":"function","title":"FilterEx.Utils.tt/1","doc":"","ref":"FilterEx.Utils.html#tt/1"},{"type":"function","title":"FilterEx.Utils.zeros/2","doc":"","ref":"FilterEx.Utils.html#zeros/2"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}